
#ifndef HANDLER_HPP
#define HANDLER_HPP

#include <string>
#include <vector>
#include <map>
#include <Poco/Runnable.h>
#include <Poco/Mutex.h>
#include "Message.hpp"


using std::string;
using std::vector;
using std::map;
using Poco::Mutex;


class Handler
{
public:

	/**
	Chat line with 'from' address.
	**/
	struct From
	{
		string from;
		
		string chatLine;
		
		From() : from(), chatLine()
		{
		}
		
		From(string frm, string line) : from(frm), chatLine(line)
		{
		}
		
		bool empty()
		{
			if (from == "" && chatLine == "")
				return true;
			return false;
		}
	};

	Handler();

	void run(Message* msg);

	/**
	Username and password for each registered user.
	**/
	static map<string, string> _members;
	
private:

	void removeUser(long sessionId);

	Mutex _mutexUsers;
	
	/**
	Maps session to username.
	**/
	map<long, string> _users;

	Mutex _mutexInbox;
	
	/**
	Inbox with messages for a specific user sent by an user.
	**/
	map<string, vector<From> > _inbox;
};


#endif // HANDLER_HPP
