
#ifndef SERVERCONNECTION_HPP
#define SERVERCONNECTION_HPP

#include <Poco/Net/StreamSocket.h>
#include <Poco/Net/ServerSocket.h>
#include <Poco/Net/TCPServerConnection.h>
#include "Session.hpp"
#include "Message.hpp"
#include "Handler.hpp"


using Poco::Net::StreamSocket;
using Poco::Net::ServerSocket;
using Poco::Net::TCPServerConnection;


class ServerConnection : public TCPServerConnection
{
public:

	ServerConnection(const StreamSocket& client);
	
	void run();
	
private:

	static const short CHUNK_SIZE = 5;
	
	static Handler _handler;
};

#endif // SERVERCONNECTION_HPP
